type 'a prioritySQ
       
val unit : 'a -> int -> 'a prioritySQ
val zero : unit -> 'a prioritySQ

val insert : 'a -> int -> 'a prioritySQ -> 'a prioritySQ
val delete : 'a -> 'a prioritySQ -> 'a prioritySQ

val to_list : 'a prioritySQ -> ('a * int) list
val from_list : ('a * int) list -> 'a prioritySQ

val lookup : 'a -> 'a prioritySQ -> int

val max_element : 'a prioritySQ -> 'a
val min_head : 'a prioritySQ -> ('a * int)
val min_tail : 'a prioritySQ -> 'a prioritySQ

val is_empty : 'a prioritySQ -> bool
val at_most : int -> 'a prioritySQ -> ('a * int) list
val at_most_range : int -> 'a -> 'a -> 'a prioritySQ -> ('a * int) list
